﻿/*
  When the gadget is launched, Open Contacts COM is not activated.
  After typing the second character in the edit box, the program will start searching,
  eventually will activate the Open Contacts COM as an out-of-process COM server.
  
*/
var foc=null;
var idsArray=null;
var htmlDetailsView;


pluginHelper.onAddCustomMenuItems = addMenuItems;

//Provide access to Open Contacts object.
function OC()
{
	try
	{
		if (foc==null)
		{
			foc = new ActiveXObject("OpenContacts.SimpleContacts");
		}
		foc.Test();  // always test whether the user close OC
	}
	catch (err)
	{
	   try
	   {
		foc = new ActiveXObject("OpenContacts.SimpleContacts"); 
		foc.Test();
	   }
	   catch (err2)
	   {
		showOCLink();
	   }
		
	}

	return foc;
}

//Show info if Open Contacts is not yet installed
function showOCLink()
{
if (htmlDetailsView == undefined) 
{
  htmlDetailsView = new DetailsView();
  htmlDetailsView.html_content = true;
}
  
  if (htmlDetailsView != undefined) 
  {
  var htmlthings = "<html><body>Google Desktop Open Contacts Gadget uses Open Contacts as data source. Open Contacts is an address program distributed as freeware. Please download and install Open Contacts v4.0.1 or above. Please check"+
"<a href=\"http://www.fonlow.com/opencontacts\">Open Contacts homepage</a> for details.</body></html>";
  htmlDetailsView.setContent("", undefined, htmlthings, false, 0);

  pluginHelper.showDetailsView(htmlDetailsView, "Information", 
    gddDetailsViewFlagToolbarOpen, onDetailsViewFeedback);
 }   

}


//used by the view in XML
function view_onOpen()
{
	if (! options.exists("QuickViewChecked"))
		options.add("QuickViewChecked", false);
		
	if (! options.exists("SearchType"))
		options.add("SearchType", 0);
	LoadTypeImage();
			
		
}

function LoadTypeImage()
{
	switch (options.item("SearchType"))
	{
		case 0 :ImgType.src = "stock_images/name32.ico";break;
		case 1 :ImgType.src = "stock_images/phone32.ico";break;
		case 2 :ImgType.src = "stock_images/mail32.ico";break;
		case 3 :ImgType.src = "stock_images/map32.ico";break;
		case 4 :ImgType.src = "stock_images/skype32.ico";break;
		case 5 :ImgType.src = "stock_images/msn32.ico";break;
		case 6 :ImgType.src = "stock_images/icq32.ico";break;
		case 7 :ImgType.src = "stock_images/qq32.ico";break;
		case 8 :ImgType.src = "stock_images/yahoo32.ico";break;
	}
	LstItems.removeAllElements();
	EdInput.value = "";

}

// Used by pluginHelper to create menu ites everytime the user click on the button
function addMenuItems(menu) {
	menu.AddItem(strName,0,loadNameImage);//0
	menu.AddItem(strPhone,0,loadPhoneImage);//1
	menu.AddItem(strEmail,0,loadEmailImage);//2
	menu.AddItem(strAddress,0,loadAddressImage);//3
	menu.AddItem(strSkype,0,loadSkypeImage);//4
	menu.AddItem(strMSN,0,loadMSNImage);//5
	menu.AddItem(strICQ,0,loadICQImage);//6
	menu.AddItem(strQQ,0,loadQQImage);//7
	menu.AddItem(strYahoo,0,loadYahooImage);//8
	//menu.AddItem("Open Contacts",0,loadOC);//9
	menu.AddItem("Quick View", options.item("QuickViewChecked") ? gddMenuItemFlagChecked : 0, SetQV);

}

// toggle Quick View
function SetQV()
{
  options.item("QuickViewChecked") = ! options.item("QuickViewChecked");
}

function loadOC()
{
  OC().ShowOC();
}

function loadPhoneImage() {options.item("SearchType") = 1;LoadTypeImage();}
function loadNameImage() {options.item("SearchType") = 0;LoadTypeImage();}
function loadEmailImage() {options.item("SearchType") = 2;LoadTypeImage();}
function loadSkypeImage() {options.item("SearchType")=4;LoadTypeImage();}
function loadICQImage() {options.item("SearchType") = 6;LoadTypeImage();}
function loadQQImage() {options.item("SearchType") = 7;LoadTypeImage();}
function loadYahooImage() {options.item("SearchType") = 8;LoadTypeImage();}
function loadAddressImage() {options.item("SearchType") = 3;LoadTypeImage();}
function loadMSNImage() {options.item("SearchType") = 5;LoadTypeImage();}

function showQV()
{
if ((htmlDetailsView == undefined) && options.item("QuickViewChecked"))
{
  htmlDetailsView = new DetailsView();
  htmlDetailsView.html_content = true;
  options.item("QuickViewChecked") = true;
}
  
  if ((htmlDetailsView != undefined) && options.item("QuickViewChecked"))
  {
  var id = idsArray[LstItems.selectedIndex];
  var htmlthings = OC().GetContactHTML(id);
  htmlDetailsView.setContent("", undefined, htmlthings, false, 0);


  // Show the details view
  pluginHelper.showDetailsView(htmlDetailsView, "Details", 
    gddDetailsViewFlagToolbarOpen, onDetailsViewFeedback);
 }   

}



function onDetailsViewFeedback(detailsViewFlags)
{
// do nothing
}

function CreateNameItem(n, id)
{
  return "<listitem  height='20' width='200' ondblclick='ListItemDblClick()'> <label valign='middle'>"+
   n+"</label></listitem>";
}

function Search(n)
{
	var c=0;
	switch (options.item("SearchType"))
	{
	  case 0: c = OC().FindContactsByName(n); break;
	  case 1: c = OC().FindContactsByPhone(n); break;
	  case 2: c = OC().FindContactsByEmail(n); break;
	  case 3: c = OC().FindContactsByFieldAction('map', n); break;
	  case 4: c = OC().FindContactsByFieldType("skype", n); break;
	  case 5: c = OC().FindContactsByFieldType('msn', n); break;
	  case 6: c = OC().FindContactsByFieldType('icq', n); break;
	  case 7: c = OC().FindContactsByFieldType('qq', n); break;
	  case 8: c = OC().FindContactsByFieldType('yahoo', n); break;
	  default:
		return;
	}
	LstItems.removeAllElements();
	if (c>0)
	{
		var ss = OC().GetIds();
		idsArray = ss.split(",");
		
		for (var i=0; i < idsArray.length; i++)
		{
			OC().LocatePeople(i);
			var item = LstItems.appendElement(CreateNameItem(OC().GetName(), idsArray[i]) );
			//item.tagName = idsArray[i];
		}
		
	}
}

function ListItemDblClick()
{
	if (options.item("QuickViewChecked"))
		showQV();
	else
	{
		OC().RestoreOC();
		OC().ViewContact(idsArray[LstItems.selectedIndex]);
	}
}


function TextChange()
{
	if (EdInput.value.length >1)
	{
		Search(EdInput.value);
	}
	
}
